function openYuplaySite()
{
  local url = getLocText("yuplay/main_url");
  ::shellExecute(url, "", "", SW_SHOWNORMAL);
}

::yuStatePrev <- -1;
::yuUpdChecked <- false;
::yuLogin <- "";
::yuPass <- "";
::yuCode <- "";

::app_state_inited <- false
::app_state_result <- -1

function openYuplaySiteRegister()
{
  local url = getLocText("yuplay/main_url") + "/register.php";
  ::shellExecute(url, "", "", SW_SHOWNORMAL);
}

function openYuplaySiteActivate()
{
//  local url = getLocText("yuplay/main_url") + "/replenishment.php?type=code";
//  ::shellExecute(url, "", "", SW_SHOWNORMAL);
  ::fastActivate();
}

function setYuplayHtml()
{
  local yuState = ::getYuplayStatus();
  if ((yuState != ::yuStatePrev) || (::app_state_result < 0))
  {
    local yuHtml = "";
    local main_url = getLocText("yuplay/main_url");
    switch (yuState)
    {
      case YUPLAY_NONE:
//        yuHtml  = "<br>" + ::getLocText("yuplay/not_installed1");
        yuHtml += " <br><br><a href='#' style='behavior:none' onClick='openYuplaySite' title='" + main_url +"'>";
        yuHtml += ::getLocText("yuplay/not_installed1");
        yuHtml += "</a>.";
    //    yuHtml = yuHtml + "&nbsp;&nbsp;&nbsp;&nbsp;(&nbsp;"+ ::getYuplayHtml2() + "&nbsp;)";
        break;

      case YUPLAY_INSTALLED:
      case YUPLAY_RUNNING:
        if (yuState != ::yuStatePrev)
          ::loginYuplay();
        yuHtml  = ::getUpdCheckHtml();
        yuHtml += "<br>";
        yuHtml += "<a href='#' style='behavior:none' onClick='loginYuplay' title=''>";
        yuHtml += ::getLocText("yuplay/login");
        yuHtml += "</a>";
        break;

      case YUPLAY_LOGGED_IN:
      case YUPLAY_ACTIVATED:
        if (!::yuUpdChecked && ::doCheckYuplayUpdates())
          checkYuplayUpdates();
        if (yuState != ::yuStatePrev)
          ::app_state_inited <- false

        yuHtml  = ::getUpdCheckHtml();
        yuHtml += "&nbsp;";
        yuHtml += ::getLocText("yuplay/hello");
        yuHtml += "&nbsp; ";
//        yuHtml += ::getYuplayLoggedNick();
        yuHtml += "<button class='yuplay-BUTTON' onClick='forceLoginYuplay'>" + ::getYuplayLoggedNick() + "!" +  "</button>" ;
        //::getLocText("yuplay/force_login") + "</button>";
        yuHtml = yuHtml + "&nbsp;&nbsp;&nbsp;&nbsp;" + ::getYuplayHtml2();
        break;
    }

    ::yuStatePrev = yuState;

    ::setHtmlRaw("yuplay", yuHtml);
  }
}


function getUpdCheckHtml()
{
  local ret  = "<input type='checkbox' id='CHECK_UPDATES' onClick='checkUpdatesClick'";
  if (::doCheckYuplayUpdates())
     ret += " checked";
  ret += ">";
  ret += ::getLocText("yuplay/check_updates");
  ret += "</input>";
  return ret;
}


function checkYuplayUpdates()
{
  //FIXME: use real game GUID and real game version
  ::yuplayCheckUpdates(::yuplay_GUID, ::game_version);
  ::yuUpdChecked = true;
}


function checkUpdatesClick()
{
  ::set_blk_bool(::settings.data, ::settings_scheme["CHECK_UPDATES"].blk,
    ::isChecked("CHECK_UPDATES"));
  ::yuStatePrev = YUPLAY_NONE;
  ::setYuplayHtml();
}


function doCheckYuplayUpdates()
{
  if (::settings.data)
    return ::get_blk_bool(::settings.data, ::settings_scheme["CHECK_UPDATES"].blk, true);

  return ::settings_scheme["CHECK_UPDATES"].defVal;
}

function getYuplayHtml2()
{
  if (! ::app_state_inited)
  {
    ::app_state_inited = ::getAppState(::yuplay_GUID)
  }
  ::app_state_result = ::getAppStateResult()

  if (::app_state_result == -1)
  {
    local html = "(&nbsp;" + ::getLocText("yuplay/checking") + "&nbsp;)"
    return html;
  }
  else if (::app_state_result == 0)
  {
    local activateDesc = ::getLocText("yuplay/activate");

    local html = "(&nbsp;" + "<a href='#' style='behavior:none' onClick='openYuplaySiteActivate'";
    html = html + "title='" + ::getLocText("yuplay/main_url") + "'>";
    html += activateDesc;
    html += "</a>" + "&nbsp;)"
//    html += "<br>";

    return html;
  }
  else
    return " ";
}

